#lang racket

(require "../alt-exp.rkt")

(read-syntax "test.xx" (open-input-string "

let: :[a 1]
      [b 2]
     +(a b)

"))

(read-syntax "test.xx" (open-input-string "

;match: 
; thing
; ['a doIt()]
; [else dontDoIt()]

define: what?(thing)
  match(thing): 
   ['a doIt()]
   [else dontDoIt()]

"))

;Hmm, this seems to wrap the contents in parens.  So, wrap in (values ...) to see all results
#reader"../alt-exp.rkt"
values

;Oh bother.  This parses fine, but the #reader puts it in expression context, not top-level defines.
#|define: f(x)
  if: (|x > 2|)
      "Hello"
      23/100|#

let: :[a 1]
      [b 2]
     +(a b)
      
;f(3)
;_(f 1)
;[f 2]


  