#lang alt-exp

define: g(x)
  if: (|x > 2|)
      "Hi there!"
      "Buh bye!"

define: !(n)
  let: loop :[ans 1]
             [n n]
       if: (|n equal? 0|)
           ans
           loop((|ans * n|) (|n - 1|))

;Test the match(thing): ... syntax
define: what?(thing)
  match(thing):
   ["a" display("Thing A\n")]
   ["b" display("Thing B\n")]
   [else display("Unknown\n")]

;Expr in function position
_(lambda: [a] a)(1)

;Next two are alt ways to write it, used while debugging parser
_(lambda( [a] a))(10)
_(lambda: [a]
          a
)(100)

let: :[a 1]
      [b 2]
     +(a b)

g(2)
g(3)
!(5)

what?("a")
what?("c")

define: #":"(x)
  printf("You gave me ~a\n" x)
  
define: #"(cool, very long id name - that has illegal chars like :, #, `)" 1000

;Test of ID_COLON with a #"" identifier
#":": #"(cool, very long id name - that has illegal chars like :, #, `)"

