; Language definition for alt-exp syntax
; Needs to be installed in the collects directory under "alt-exp/lang/reader.rkt"

(module reader syntax/module-reader
  racket
  #:read read
  #:read-syntax read-syntax
  #:whole-body-readers? #t
  #:info (lambda (key defval default)
           (case key
             ;[(color-lexer)
             ; (dynamic-require 'datalog/tool/syntax-color 'get-syntax-token)]
             [(drracket:submit-predicate)
              (dynamic-require 'alt-exp/lang/submit 'repl-submit?)]
             [(configure-runtime)
              (λ ()
                (printf "Configuring\n") 
                (current-read-interaction 
                 (λ args
                   (printf "My read\n")
                   (apply read args))))]
             [else (default key defval)]))
  (require alt-exp/alt-exp))
